using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid.Grouping;


namespace UnBoundedHashTable_GGC
{
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		private System.ComponentModel.Container components = null;
		private Hashtable A,B,C;

		public Form1()
		{
			InitializeComponent();
		}
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code

		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 16);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(432, 248);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.Name = "Default";
			this.gridGroupingControl1.Text = "gridGroupingControl1";			
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(464, 278);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.gridGroupingControl1.DataSource = GetTable();	

			# region UnBoundFields
			this.gridGroupingControl1.TableDescriptor.UnboundFields.Add("C");			
			this.gridGroupingControl1.TableControl.Model.ColStyles[3].ReadOnly = true;		
			# endregion

			# region HashTable
			C = new Hashtable();
			Random n = new Random();
			Console.WriteLine(this.gridGroupingControl1.TableControl.Model.RowCount.ToString());
			for(int i = 4; i <= this.gridGroupingControl1.TableControl.Model.RowCount ; i++)			
				C[this.gridGroupingControl1.Table.DisplayElements[i].ParentRecord] = n.Next();							
			# endregion

			this.gridGroupingControl1.TableDescriptor.QueryValue += new FieldValueEventHandler(unboundField_QueryValue); // Routine that queries for the value
			this.gridGroupingControl1.TableDescriptor.SaveValue += new FieldValueEventHandler(unboundField_SaveValue); // Routine that queries for the value
		}
		
		# region DataTable 
		private DataTable GetTable()
		{
			int nCols = 2;
			int nRows = 10;

			DataTable dt = new DataTable("table");
			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					dr[j] = string.Format("row{0} col{1}", i, j);
					
				}
				dt.Rows.Add(dr);
			}
			return dt;
		}
		# endregion

		# region Events [ QueryValue & SaveValue ]
		private void unboundField_QueryValue(object sender, FieldValueEventArgs e)
		{			
			if (e.Field.Name == "C")
			{
				object value = C[e.Record];
				if (value != null)
					e.Value= value;
			}
		}

		private void unboundField_SaveValue(object sender, FieldValueEventArgs e)
		{
			if (e.Field.Name == "C" )
			{
				C[e.Record] = e.Value;
			}
		}
		# endregion
	}
}
